// Using SQLiteCrypt DLLView.cpp : implementation of the CUsingSQLiteCryptDLLView class
//

#include "stdafx.h"
#include "Using SQLiteCrypt DLL.h"

#include "Using SQLiteCrypt DLLDoc.h"
#include "Using SQLiteCrypt DLLView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CUsingSQLiteCryptDLLView

IMPLEMENT_DYNCREATE(CUsingSQLiteCryptDLLView, CView)

BEGIN_MESSAGE_MAP(CUsingSQLiteCryptDLLView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_HELP_TEST, &CUsingSQLiteCryptDLLView::OnHelpTest)
END_MESSAGE_MAP()

// CUsingSQLiteCryptDLLView construction/destruction

CUsingSQLiteCryptDLLView::CUsingSQLiteCryptDLLView()
{
	// TODO: add construction code here

}

CUsingSQLiteCryptDLLView::~CUsingSQLiteCryptDLLView()
{
}

BOOL CUsingSQLiteCryptDLLView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CUsingSQLiteCryptDLLView drawing

void CUsingSQLiteCryptDLLView::OnDraw(CDC* /*pDC*/)
{
	CUsingSQLiteCryptDLLDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CUsingSQLiteCryptDLLView printing

BOOL CUsingSQLiteCryptDLLView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CUsingSQLiteCryptDLLView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CUsingSQLiteCryptDLLView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CUsingSQLiteCryptDLLView diagnostics

#ifdef _DEBUG
void CUsingSQLiteCryptDLLView::AssertValid() const
{
	CView::AssertValid();
}

void CUsingSQLiteCryptDLLView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CUsingSQLiteCryptDLLDoc* CUsingSQLiteCryptDLLView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CUsingSQLiteCryptDLLDoc)));
	return (CUsingSQLiteCryptDLLDoc*)m_pDocument;
}
#endif //_DEBUG


// CUsingSQLiteCryptDLLView message handlers
#include "sqlite3.h"
//////////////////////////////////////////////////
void Test02()
{
	double test = 0;
	sqlite3 *db;
	int res;

	sqlite3_open_v2("data.db", &db, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
    sqlite3_stmt* stm;
	const char* errMsg;
    const char *pzTail;
    {
		res = sqlite3_prepare(db, "PRAGMA key = 'abc123';", -1, &stm, &pzTail);
		res = sqlite3_step(stm);
		//please change license below to yours before compilation
		res = sqlite3_prepare(db, "PRAGMA lic = '77523-009-0000007-72328';", -1, &stm, &pzTail);
		res = sqlite3_step(stm);
		//res = sqlite3_prepare(db, "PRAGMA rekey = 'abc123';", -1, &stm, &pzTail);
        //res = sqlite3_step(stm);

        // TableA Create.
        res = sqlite3_prepare(db, "create table _MapPropertyA(dXOff DOUBLE, dYOff DOUBLE);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        
        res = sqlite3_prepare(db, "insert into _MapPropertyA values(3, 8);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        
        // TableB Create. (Add primary key)
        res = sqlite3_prepare(db, "create table _MapPropertyB(dXOff DOUBLE primary key, dYOff DOUBLE);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        
        res = sqlite3_prepare(db, "insert into _MapPropertyB values(3, 8);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        		
        // TableA Select
        /* OUTPUT ==> OK - test = 3.000000 */
        res = sqlite3_prepare(db, "select dXOff from _MapPropertyA;", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        if (res == SQLITE_ROW) {
            test = sqlite3_column_double(stm, 0);
            //CCLog("OK - test = %f", test);
            
        } else {
            errMsg = (char *)sqlite3_errmsg(db);
            //CCLog("Error - Message: %s, Code: %d", errMsg, res);
            
        }
        
        // TableA Select and Order
        /* OUTPUT ==> OK */
        res = sqlite3_prepare(db, "select dXOff from _MapPropertyA ORDER BY dXOff;", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        if (res == SQLITE_ROW) {
            test = sqlite3_column_double(stm, 0);
            //CCLog("OK - test = %f", test);
            
        } else {
            errMsg = (char *)sqlite3_errmsg(db);
            //CCLog("Error - Message: %s, Code: %d", errMsg, res);
            
        }
        
        // TableB Select and Order
        /* OUTPUT ==> OK - test = 3.000000 */
        res = sqlite3_prepare(db, "select dXOff from _MapPropertyB ORDER BY dXOff;", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        if (res == SQLITE_ROW) {
            test = sqlite3_column_double(stm, 0);
            //CCLog("OK - test = %f", test);
            
        } else {
            errMsg = (char *)sqlite3_errmsg(db);
            //CCLog("Error - Message: %s, Code: %d", errMsg, res);
            
        }
    }
    
    sqlite3_finalize(stm);
    sqlite3_close(db);
}//////////////////////////////////////

int WINAPI Test03()
{
	double test = 0;
	sqlite3 *db;
	int res;

	sqlite3_open_v2("data2.db", &db, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
    sqlite3_stmt* stm;
	const char* errMsg;
    const char *pzTail;
    {
		res = sqlite3_prepare(db, "PRAGMA key = 'abc123';", -1, &stm, &pzTail);
		res = sqlite3_step(stm);
		//please change license below to yours before compilation
		res = sqlite3_prepare(db, "PRAGMA lic = '77523-009-0000007-72328';", -1, &stm, &pzTail);
		res = sqlite3_step(stm);
		//res = sqlite3_prepare(db, "PRAGMA rekey = 'abc123';", -1, &stm, &pzTail);
        //res = sqlite3_step(stm);

        // _MapPro Create.
        res = sqlite3_prepare(db, "create table ABC(dXOff DOUBLE, dYOff DOUBLE);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        
        res = sqlite3_prepare(db, "insert into ABC values(100.0, 200.0);", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        
                		
        /* OUTPUT ==> OK - test = 100.000000 */
        res = sqlite3_prepare(db, "select dXOff from ABC;", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        if (res == SQLITE_ROW) {
            test = sqlite3_column_double(stm, 0);
            //CCLog("OK - test = %f", test);
            
        } else {
            errMsg = (char *)sqlite3_errmsg(db);
            //CCLog("Error - Message: %s, Code: %d", errMsg, res);
            
        }
        
        // Select and Order
        /* OUTPUT ==> OK */
        res = sqlite3_prepare(db, "select dXOff from ABC ORDER BY dXOff;", -1, &stm, &pzTail);
        res = sqlite3_step(stm);
        if (res == SQLITE_ROW) {
            test = sqlite3_column_double(stm, 0);
            //CCLog("OK - test = %f", test);
            
        } else {
            errMsg = (char *)sqlite3_errmsg(db);
            //CCLog("Error - Message: %s, Code: %d", errMsg, res);
            
        }
    }
    
    sqlite3_finalize(stm);
    sqlite3_close(db);
	return 0;
}

int WINAPI Test01()
{
	const unsigned char* sTest = 0;
	sqlite3 *db;
	int res;

	sqlite3_open_v2("cddb_light", &db, SQLITE_OPEN_READWRITE, NULL);
    sqlite3_stmt* stm;
	const char* errMsg;
    const char *pzTail;
    
	res = sqlite3_prepare(db, "PRAGMA key = 'abc123';", -1, &stm, &pzTail);
	res = sqlite3_step(stm);
	//please change license below to yours before compilation
	res = sqlite3_prepare(db, "PRAGMA lic = '77523-009-0000007-72328';", -1, &stm, &pzTail);
	res = sqlite3_step(stm);
	//res = sqlite3_prepare(db, "PRAGMA rekey = 'abc123';", -1, &stm, &pzTail);
    //res = sqlite3_step(stm);

    res = sqlite3_prepare(db, "select * from rhymes;", -1, &stm, &pzTail);
    res = sqlite3_step(stm);
    if (res == SQLITE_ROW) {
		sTest = sqlite3_column_text(stm, 0);
            
    } else {
        errMsg = (char *)sqlite3_errmsg(db);
    }
    
    sqlite3_finalize(stm);
    sqlite3_close(db);
	return 0;
}
///////////////////////////////////////
void CUsingSQLiteCryptDLLView::OnHelpTest()
{
	Test02();

	//HANDLE theThread = CreateThread(NULL, 4096, (LPTHREAD_START_ROUTINE )Test03, this, STACK_SIZE_PARAM_IS_A_RESERVATION, NULL); 
	return;
}

